/*
*    Copyright (C) 1995 Ronald Van Iwaarden
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    I can presently be contacted on the internet at
*
*    rvaniwaa@carbon.denver.colorado.edu
*    rvaniwaa@smaug.cs.hope.edu
*   
*    or by snail mail at:
*
*    Ronald Van Iwaarden
*    4351 60th St.
*    Holland MI, USA, 49423
*/


#include "maxfdefine.h"
#include "mem.h"
#include <stdlib.h>
#include <sys/winmgr.h>
#include <os2.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include "maxfstruct.h"

#include "utils.h"



extern char American_date;



int Nameincr( struct FileInfo * file1, struct FileInfo * file2)
{
  return stricmp(mygetname(file1->fname), mygetname(file2->fname));
}



int Namedecr( struct FileInfo * file1, struct FileInfo * file2)
{
  return -stricmp(mygetname(file1->fname), mygetname(file2->fname)); 
}







int dateincr(struct FileInfo * file1, struct FileInfo * file2)
{
  char date1[10];
  char date2[10];
  char * p1;
  char * p2;
  int retval;
  int d1, d2;
  
  strcpy(date1, file1->date);
  strcpy(date2, file2->date);
  if (!stricmp(file2->date, "offline ")) return 1;
  else if (!stricmp(file1->date, "offline ")) return -1;
  else
    {
      p1 = &date1[6];
      p2 = &date2[6];
      if (strtol(p1, NULL, 10) < strtol(p2, NULL, 10))
	return -1;
      else if (strtol(p1, NULL, 10) > strtol(p2, NULL, 10))
	return 1;
      
      if (American_date){
	date1[2] = date1[3];
	date1[3] = date1[4];

	date2[2] = date2[3];
	date2[3] = date2[4];

	date1[4] = 0;
	date2[4] = 0;
      }
      else{
	date1[2] = date1[0];
	date1[0] = date1[3];
	date1[3] = date1[1];
	date1[1] = date1[4];
	date2[2] = date2[0];
	date2[0] = date2[3];
	date2[3] = date2[1];
	date2[1] = date2[4];
	date1[4] = 0;
	date2[4] = 0;
      }
      d1 = strtol(date1, NULL, 10);
      d2 = strtol(date2, NULL, 10);
      retval = d1-d2;
    }
  return retval;
}



int datedecr(struct FileInfo * file1, struct FileInfo * file2)
{
  char date1[10];
  char date2[10];
  char * p1;
  char * p2;
  char retval;
  int d1, d2;
  
  strcpy(date1, file1->date);
  strcpy(date2, file2->date);
  if (!stricmp(file2->date, "offline ")) return 1;
  else if (!stricmp(file1->date, "offline ")) return -1;
  else
    {
      p1 = &date1[6];
      p2 = &date2[6];
      if (strtol(p1, NULL, 10) < strtol(p2, NULL, 10))
	return -1;
      else if (strtol(p1, NULL, 10) > strtol(p2, NULL, 10))
	return 1;
      
      if (American_date){
	date1[2] = date1[3];
	date1[3] = date1[4];
	date2[2] = date2[3];
	date2[3] = date2[4];
	date1[4] = 0;
	date2[4] = 0;
      }
      else{
	date1[2] = date1[0];
	date1[0] = date1[3];
	date1[3] = date1[1];
	date1[1] = date1[4];
	date2[2] = date2[0];
	date2[0] = date2[3];
	date2[3] = date2[1];
	date2[1] = date2[4];
	date1[4] = 0;
	date2[4] = 0;
      }
      d1 = strtol(date1, NULL, 10);
      d2 = strtol(date2, NULL, 10);
      retval = d2 - d1;
    }
  return -retval;
}




/* this returns 1 if the size of file 1 is less than the size of file 2 */
int sizeincr(struct FileInfo * file1, struct FileInfo * file2)
{
  int num1;
  int num2;

  if (!file1->fsize) return -1;
  if (!file2->fsize) return 1;

  num1 = strtol(file1->fsize, NULL, 10);
  num2 = strtol(file2->fsize, NULL, 10);
  
  return num1-num2;
}


int sizedecr(struct FileInfo * file1, struct FileInfo * file2)
{
  int num1;
  int num2;

  if (!file1->fsize) return 1;
  if (!file2->fsize) return -1;

  num1 = strtol(file1->fsize, NULL, 10);
  num2 = strtol(file2->fsize, NULL, 10);

  return num2 - num1;
}


void QuickSort(struct FileInfo * list, int num, int compare)
{
  void * base = list;  
  
  switch (compare){
    
  case 1:  qsort(base, num, sizeof(struct FileInfo), (void *)dateincr);
    break;
  case -1: qsort(base, num, sizeof(struct FileInfo), (void *)datedecr);
    break;
  case 2:  qsort(base, num, sizeof(struct FileInfo), (void *)sizeincr);
    break;
  case -2: qsort(base, num, sizeof(struct FileInfo), (void *)sizedecr);
    break;
  case 3:  qsort(base, num, sizeof(struct FileInfo), (void *)Nameincr);
    break;
  case -3: qsort(base, num, sizeof(struct FileInfo), (void *)Namedecr);
    break;
  }
}
