/*
*    Copyright (C) 1995 Ronald Van Iwaarden
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    I can presently be contacted on the internet at
*
*    rvaniwaa@carbon.denver.colorado.edu
*    rvaniwaa@smaug.cs.hope.edu
*   
*    or by snail mail at:
*
*    Ronald Van Iwaarden
*    4351 60th St.
*    Holland MI, USA, 49423
*/


#include "maxfdefine.h"
#include "mem.h"
#include <process.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <os2.h>
#include <string.h>
#include <sys/kbdscan.h>
#include <sys/winmgr.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <time.h>
#include <strings.h>
#include "maxfdefine.h"
#include "maxfstruct.h"

#include "error.h"
#include "utils.h"


extern int FileListMargin;
extern char * Macros[numMacros];
extern char WrapComments;
extern int num_windows;
extern int VerticalWindow;
extern int ReadOnlyColour;
extern int OfflineColour;
extern int NameColour;
extern int CommentColour;
extern int HighlightColour;
extern int SizeColour;
extern int DateColour;
extern int DescColour;
extern char American_date;
extern int zorder[];
extern char * maxdir;
extern struct archiver archivers[maxarchivers];
extern struct FileArea * fileareas;
extern struct Window windowlist[maxwindows];
extern char bbs_type;
extern char * fbpcmd;
extern char * areabbs;
extern int AutoFBP;
extern char * GifViewer;
extern char * BMPViewer;
extern char * JPGViewer;
extern char * PCXViewer;
extern char * TIFViewer;
extern char * TXTViewer;
extern char * VirusScanner;
extern char * DefaultDescription;
extern char * externaledit;
extern char * TempDir;

extern int MidX;
extern int MidY;
extern int MaxX;
extern int MaxY;





int min(int a, int b)
{
  return (a < b) ? a : b;
}






/*This is a procedure to compute y = x^kmod n */
int exponentiate(unsigned long long x, unsigned long long k, unsigned n)
{
  int bits[32] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  unsigned long long y;
  unsigned temp;
  int i;

  for(i=31; i >= 0; --i){
    temp = k;
    temp = temp << i;
    temp = temp >> 31;
    bits[31-i] = temp;}
  y = 1;
  for (i = 31; i >= 0; --i){
    y = (y*y)%n;
    if (bits[i]) y = (y*x) % n;}
  return (int) y;
}





/* This returns the number of the window that is on the top.*/
int top(int * zorder)
{
  int i = 0;
  while (zorder[i] != 1) ++i;
  return i;
}


/* obvious, it returns the absolute value of an integer*/
int abs(int x)
{
  return (x > 0) ? x : -x;
}


/* This returns the number of the last file displayed in win*/
int max_vis_file(struct Window *win)
{
  int i = 0;
  while (win->FileStart[i+1] >=0) ++i;
  return i;
}




char * first_non_space(char * str)
{
  char * p = str;

  while ((p) && (isspace(*p))) ++p;
  return p;
}




char * desccat(char * olddesc, char * newdesc)
{
  char *tempdesc = mem_realloc(olddesc, strlen(olddesc) + strlen(newdesc)+10);
  strcat(tempdesc, newdesc);
  return tempdesc;
}




char * Format_File(struct Window * win, int pos, char * str)
{
  char tempstr2[50];
  char * tempstr;
  
  if(is_selected(win, pos))
    tempstr = mem_strdup("*");
  else
    tempstr = mem_strdup(" ");
  tempstr = desccat(tempstr, mygetname(win->Files[pos].fname));
  if (win->date){
    sprintf(tempstr2, "%s ", win->Files[pos].date);
    tempstr = desccat(tempstr, tempstr2);}
  if (win->size){
    sprintf(tempstr2, "%s ", win->Files[pos].fsize);
    tempstr = desccat(tempstr, tempstr2);}
  tempstr = desccat(tempstr, win->Files[pos].description);
  return tempstr;
}





void date2str(FDATE date , char * datestr)
{
  char junk[20];
  char str2[20];

  if (American_date)
    {
      if(date.month < 10){
	strcpy(junk, "0");
	strcat(junk, _ltoa(date.month, str2, 10));}
      else strcpy(junk, _ltoa(date.month, str2, 10));
      strcat(junk, "/");
      if(date.day < 10) strcat(junk, "0");
      strcat(junk, _ltoa(date.day, str2, 10));
    }
  else
    {
      if(date.day < 10){
	strcpy(junk, "0");
	strcat(junk, _ltoa(date.day, str2, 10));}
      else strcpy(junk, _ltoa(date.day, str2, 10));
      strcat(junk, "/");
      if(date.month < 10) strcat(junk, "0");
      strcat(junk, _ltoa(date.month, str2, 10));
    }

  strcat(junk, "/");
  strcat(junk, _ltoa(date.year+80, str2, 10));
  strcpy(datestr, junk);
}




void d_date2str(struct d_date * date , char * datestr)
{
  char junk[20];
  char str2[20];

  if (American_date)
    {
      if(date->month < 10){
	strcpy(junk, "0");
	strcat(junk, _ltoa(date->month, str2, 10));}
      else strcpy(junk, _ltoa(date->month, str2, 10));
      strcat(junk, "/");
      if(date->day < 10) strcat(junk, "0");
      strcat(junk, _ltoa(date->day, str2, 10));
    }
  else
    {
      if(date->day < 10){
	strcpy(junk, "0");
	strcat(junk, _ltoa(date->day, str2, 10));}
      else strcpy(junk, _ltoa(date->day, str2, 10));
      strcat(junk, "/");
      if(date->month < 10) strcat(junk, "0");
      strcat(junk, _ltoa(date->month, str2, 10));
    }

  strcat(junk, "/");
  strcat(junk, _ltoa(date->year+80, str2, 10));
  strcpy(datestr, junk);
}


void t_date2str(time_t date , char * datestr)
{
  char junk[20];

  struct tm *tm_struct = localtime(&date);

  if (American_date) strftime(junk, 20, "%D", tm_struct);
  else strftime(junk, 20, "%d/%m/%y", tm_struct);

  strcpy(datestr, junk);
}





void mygets(wm_handle wm, char * str, int x, int y, int length)
{
  /* This procedure will read in the string str from window wm at the
     point x,y.  The string can have a maximum length of length */

  int i = 0;
  int width, height;
  wm_gotoxy(wm,x,y);

  wm_dimen(wm, &width, &height);
  while (((str[i] = _read_kbd(0,1,0)) != 13) && (i < length)){

    if (str[i] == ESCAPE)
      {
	str[0] = 0;
	return;
      }
    if (str[i] != DELETE)
      {
	++i;
	if (i == length) --i;
	else wm_putc(wm, str[i-1]);
      }
    else if (i > 0)
      {
	--i;
	wm_backsp(wm,1);
	wm_putc(wm,' ');
	wm_backsp(wm,1);
      };
  };
  str[i] = 0;
}





char * mygetname(char * path)
{
  char * p = &path[strlen(path)];
  while ((p != path) && (*p != '\\') && (*p != '/')) --p;
  if ((*p == '\\') || (*p == '/')) ++p;
  return p;
}





void size2str(char* str, int size)
{
  char str2[20];

  _ltoa(size, str2, 10);
  switch (strlen(str2))
    {
    case 1: strcpy(str, "     "); break;
    case 2: strcpy(str, "     "); break;
    case 3: strcpy(str, "    "); break;
    case 4: strcpy(str, "   "); break;
    case 5: strcpy(str, "  "); break;
    case 6: strcpy(str, " "); break;
    case 7: strcpy(str, ""); break;
    }
  strcat(str, str2);
}


char * getfname(char * tempstr)
{
  wm_handle fname_win;
  
  if (!tempstr) strcpy(tempstr, "");
  fname_win = wm_create(MidX-6, MidY, MidX+6,MidY,
			2, BW_NORMAL|INTENSITY, BW_NORMAL|INTENSITY);

  if (tempstr) wm_border(fname_win, 2, BW_NORMAL|INTENSITY,
			 mygetname(tempstr), 1, BW_NORMAL|INTENSITY);
  else wm_border(fname_win, 2, BW_NORMAL|INTENSITY,
		 "Filename?",1, BW_NORMAL|INTENSITY);
  wm_open(fname_win);
  wm_top(fname_win);
  wm_cvis(fname_win, 1);
  wm_cursor(fname_win);
  mygets(fname_win, tempstr, 0,0, 13);
  wm_close(fname_win);
  wm_delete(fname_win);
  return tempstr;
}



/*
   This function opens a small window and allows the user to select an
   archive type.  The archive type extension is returned in ext and the
   number of the archiver is returned.  If the user presses "escape", the
   value 0 is returned.
*/

int get_a_type(char * ext)
{
  wm_handle a_type;
  int choices[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  int i;
  int j = 0;
  char types[][4] = {"zip", "arj", "lzh", "arc", ""};
  int selection=0;
  int choice=0;

  for (i=0; i < 5; ++i)
    if (strlen(archivers[i].add)) choices[j++] = i;
  i = 0; while(choices[i+1]) ++i;
  a_type = wm_create(MaxX/2-5, MaxY/2-i/2, MaxX/2+4, MaxY/2+i/2,
		     2, BW_NORMAL, BW_NORMAL);
  wm_border(a_type, 2, F_YELLOW|B_BLACK|INTENSITY,
	    "New Type?",1,F_RED|B_WHITE|INTENSITY);
  wm_open(a_type);
  wm_top(a_type);
    for(j=0; j <= i; ++j)
      wm_puts_at(a_type, 0,j,types[choices[j]]);
    wm_puta_at(a_type, 0, 0, B_WHITE|F_BLACK, 4);
    while((choice != ENTER) && (choice != ESCAPE))
      {
	choice = _read_kbd(0,1,0);
	switch(choice)
	  {
	  case K_DOWN:
	    if (selection < i){
	      wm_puta_at(a_type, 0,selection, F_WHITE|B_BLACK|INTENSITY,4);
	      ++selection;
	      wm_puta_at(a_type, 0,selection, B_WHITE|F_BLACK,4);
	    }
	    break;
	  case K_UP:
	    if (selection > 0){
	      wm_puta_at(a_type, 0,selection, F_WHITE|B_BLACK|INTENSITY,4);
	      --selection;
	      wm_puta_at(a_type, 0,selection, B_WHITE|F_BLACK,4);
	    }
	    break;
	  }
      }
  wm_close(a_type);
  wm_delete(a_type);
  strcpy(ext, types[choices[selection]]);
  if (choice == ENTER) return choices[selection] + 1;
  else return 0;
}



/*
   This function will recursively remove the directory name, all the files
   in name and all the files in all the directories below name
*/


void remove_recursively(char *name)
{
  DIR * directory;
  struct dirent * Dirinfop;
  char fname[300];

  if ((directory = opendir(name))){
    
    while ((Dirinfop = readdir(directory)))
      {
	sprintf(fname,"%s\\%s",name, Dirinfop->d_name);
	if(Dirinfop->d_name[0] != '.')
	  {
	    if (Dirinfop->d_attr == 16)
	      {
		remove_recursively(fname);
		rmdir(fname);
	      }
	    else
	      remove(fname);
	  }
      }
    closedir(directory);
    rmdir(name);
  }
  else remove(name);
}



/*
   This procedure returns a number corresponding to the archive type of
   the file fname.  It returns 0 if the file does not correspond to a
   known archive type.
*/

int archive_type(char * fname)
{
  char * extension;
  char temp[90];
  int i;
  strcpy(temp,mygetname(fname));
  extension = strtok(temp, " ");
  i = 0;
  while ((*extension != '.') && (i < strlen(extension))) ++extension;
   ++extension;

  if (!stricmp(extension, "zip"))
    return 1;
  else if (!stricmp(extension, "arj"))
     return 2;
  else if (!stricmp(extension, "lzh"))
    return 3;
  else if (!stricmp(extension, "arc"))
    return 4;
  return 0;
}



void re_display_window(struct Window *win, int x0, int y0, int x1, int y1)
{
  char title[230];
  wm_handle temphandle = win->Handle;

  win->Handle = wm_create(x0, y0, x1, y1,2,
			  BW_NORMAL, DescColour|B_BLACK|INTENSITY);
  wm_open(win->Handle);
  wm_close(temphandle);
  wm_delete(temphandle);
  wm_top(win->Handle);
  wm_dimen(win->Handle, &win->width, &win->depth);
  strcpy(title, fileareas[win->area].Area);
  strcat(title,": ");
  strcat(title, fileareas[win->area].FileInfo);
  strcat(title, win->dirsize);
  title[win->width-2] = 0;
  wm_border(win->Handle, 2, BW_NORMAL|INTENSITY,
	    title, 1, BW_NORMAL|INTENSITY);
  displaylist(win);
  while ((win->highlight > max_vis_file(win)) && win->highlight)
    --win->highlight;
  wm_highlight(win, 1);
}


void maximize(struct Window *win)
{
  re_display_window(win, 1, 2, MaxX-2, MaxY-2);
}

void normalize(struct Window *win)
{
  if (VerticalWindow){
    if (win == &windowlist[1])
      re_display_window(win, 1, 2, MidX-2, MaxY-2);
    else
      re_display_window(win, MidX+1, 2, MaxX-2, MaxY-2);
  }
  else{
    if (win == &windowlist[1])
      re_display_window(win, 1, 2, MaxX-2, MaxY/2-2);
    else
      re_display_window(win, 1, MaxY/2+1, MaxX-2, MaxY-2);
  }
}


void grow_right(struct Window *win)
{
  int xpos, ypos;

  wm_get_pos(win->Handle, &xpos, &ypos);
  if (xpos + win->width < MaxX-1)
    re_display_window(win, xpos, ypos, xpos+win->width,ypos+win->depth-1);
}


void grow_left(struct Window *win)
{
  int xpos, ypos;

  wm_get_pos(win->Handle, &xpos, &ypos);
  if (xpos > 1)
    {
      --xpos;
      re_display_window(win, xpos, ypos, xpos+win->width,ypos+win->depth-1);
    }
}


void shrink_right(struct Window * win)
{
  int xpos, ypos;

  wm_get_pos(win->Handle, &xpos, &ypos);
  if (win->width > 29)
    re_display_window(win, xpos, ypos, xpos+win->width-2,ypos+win->depth-1);
}


void grow_up(struct Window *win)
{
  int xpos, ypos;

  wm_get_pos(win->Handle, &xpos, &ypos);
  if (ypos > 2)
    re_display_window(win, xpos, ypos-1, xpos+win->width-1,ypos+win->depth-1);
}


void shrink_up(struct Window * win)
{
  int xpos, ypos;

  wm_get_pos(win->Handle, &xpos, &ypos);
  if (win->depth > 6)
    re_display_window(win, xpos, ypos+1, xpos+win->width-1,ypos+win->depth-1);
}


void grow_down(struct Window *win)
{
  int xpos, ypos;

  wm_get_pos(win->Handle, &xpos, &ypos);
  if (ypos+win->depth+1 < MaxY)
    re_display_window(win, xpos, ypos, xpos+win->width-1,ypos+win->depth);
}


void shrink_down(struct Window * win)
{
  int xpos, ypos;

  wm_get_pos(win->Handle, &xpos, &ypos);
  if (win->depth > 6)
    re_display_window(win, xpos, ypos, xpos+win->width-1,ypos+win->depth-2);
}


void shrink_left(struct Window *win)
{
  int xpos, ypos;


  wm_get_pos(win->Handle, &xpos, &ypos);
  if (win->width > 29)
    {
      ++xpos;
      re_display_window(win, xpos, ypos, xpos+win->width-2,ypos+win->depth-1);
    }
}

void TITLE(struct Window * win, int area)
{
  char title[150];
  sprintf(title, "%s: %s %s", fileareas[area].Area,
	  fileareas[area].FileInfo, win->dirsize);
  title[win->width-2] = 0;
  wm_border(win->Handle, 2, BW_NORMAL|INTENSITY,
	    title, 1, F_WHITE|B_BLACK|INTENSITY);
}

void displaylist(struct Window *win)
{
  int i=win->top_display;
  int j = 0;
  int depth = 0;
  int more;
  char *tempstr = NULL;
  char *eol;
  char *p;
  int first;
  int rc;
  char store = ' ';

  win->all_displayed = 0;
  win->FileStart[0] = 0;
  wm_clear(win->Handle);
  TITLE(win, win->area);
  if (!win->numfiles)
    {
      win->FileStart[0] = 0;
      win->FileStart[1] = -1;
      win->all_displayed = 1;
      return;
    }
  while ((depth < win->depth) && (i < win->numfiles))
    {
      mem_free(tempstr);
      tempstr = Format_File(win, i, tempstr);
      p = tempstr;
      first = 1;
      more = 1;
      while((depth < win->depth) && (more))
	{
	  eol = &p[ min(win->width, strlen(p)) ];
	  if (strlen(p) <= win->width){
	    wm_puts_at(win->Handle, 0, depth ,p);
	    more = 0;}
	  if (more){
	    while ((*eol != ' ') && (eol > p)) eol--;
	    if (eol == p)
	      {
		store = *p; 
		p[win->width] = 0; 
		eol = &p[win->width];
	      }
	    else{ *eol = 0; store = ' ';}
	  }
	  wm_puts_at(win->Handle, 0, depth, p);
	  if (more) *eol = store;
	  p = eol;
	  if (!win->wrap) more = 0;
	  rc = strnicmp(&tempstr[1], "COMMENTS", strlen("COMMENTS")); 
	  if (!rc && !WrapComments) more = 0;
	  if (first) highlight_date_time(win,depth,0,win->Files[i].read_only);
	  first = 0;
	  ++depth;
	  if (!*p) more = 0;
	}
      ++i;
      win->FileStart[++j] = depth;
    }
  /* if we have reached the bottom of the Window and not displayed everything,
     set the next FileStart negative so that we know that.  If not, set the
     win->all_displayed to 1 */
  if (depth >= win->depth)
    {
      --j;
      win->all_displayed = 0;
    }
  else
    {
      win->all_displayed = abs(win->FileStart[j]) - win->FileStart[j-1];
      win->FileStart[j+1] = 0;
    }
  win->FileStart[j]=-win->FileStart[j];
  win->bottom_display = i;
  mem_free (tempstr);
}



void wm_highlight(struct Window *win, int BACK)
{
  int num = win->highlight;
  int Read_Only = win->Files[num + win->top_display].read_only;
  int i;
  if (BACK) {
    /* First highlight any of the file name, date, or size */
    wm_puta_at(win->Handle,0,abs(win->FileStart[num]),
	       DescColour|HighlightColour|INTENSITY,win->width);
    highlight_date_time(win, abs(win->FileStart[num]), 1, Read_Only);
    for(i = win->FileStart[num]+1; i<abs(win->FileStart[num+1]); ++i)
      wm_puta_at(win->Handle,0,i,
		 DescColour|HighlightColour|INTENSITY,win->width);
  }
  else if (!BACK)
    {
      /* First highlight any of the file name, date, or size */
      wm_puta_at(win->Handle,0,win->FileStart[num],
		 DescColour|B_BLACK|INTENSITY,win->width);
      highlight_date_time(win, win->FileStart[num], 0, Read_Only);
      for(i = win->FileStart[num]+1; i <abs(win->FileStart[num+1]); ++i)
	wm_puta_at(win->Handle,0,i,DescColour|B_BLACK|INTENSITY,win->width);
    }
  else if (win->numfiles == 0)
    wm_puta_at(win->Handle,0,0,
	       DescColour|HighlightColour|INTENSITY,win->width);
}




void wm_up_all()
{
  int i, j;
  char title[130];
  int TOP = 0;
  for (i = 1;i<=num_windows; ++i)
    {
      sprintf(title,"%s: %s%s", fileareas[windowlist[i].area].Area,
	      fileareas[windowlist[i].area].FileInfo, windowlist[i].dirsize);
      title[windowlist[i].width-2] = 0;
      --zorder[i];
      if (zorder[i] != 0) wm_up(windowlist[i].Handle);
      if (zorder[i] == 1)
	{
	  wm_border(windowlist[i].Handle, 2, BW_NORMAL|INTENSITY,
		    title, 1, BW_NORMAL|INTENSITY);
	  TOP = 1;
	}

      else if (zorder[i] == 0)
	{
	  wm_border(windowlist[i].Handle, 2, BW_NORMAL, title, 1, BW_NORMAL);
	  for (j=1;j<num_windows-TOP-1; ++j)
	    wm_bottom(windowlist[i].Handle);
	  zorder[i] = num_windows;
	}
    }
}




/* This will highlight the date and time with the standard colors.  BG
   determines what color the back ground is.
*/

void highlight_date_time(struct Window *win, int depth, int bg, int readonly)
{
  if (bg)
    {
      if (readonly == READ_ONLY)
	wm_puta_at(win->Handle,0,depth,
		   ReadOnlyColour|HighlightColour|INTENSITY,13);
      if (readonly == OFFLINE)
	wm_puta_at(win->Handle,0,depth,
		   OfflineColour|HighlightColour|INTENSITY,13);
      else if (!readonly)
	wm_puta_at(win->Handle,0,depth,
		   NameColour|HighlightColour|INTENSITY,13);
      else if (readonly == FILE_COMMENT)
	wm_puta_at(win->Handle,0,depth,
		   CommentColour|HighlightColour|INTENSITY,13);
      if((win->date) && (win->size)){
	wm_puta_at(win->Handle,13,depth,
		   DateColour|HighlightColour|INTENSITY,9);
	wm_puta_at(win->Handle,23,depth,
		   SizeColour|HighlightColour|INTENSITY,7);
      }
      else if(win->date)
	wm_puta_at(win->Handle,13,depth,
		   DateColour|HighlightColour|INTENSITY,9);
      else if (win->size)
	wm_puta_at(win->Handle,14,depth,
		   SizeColour|HighlightColour|INTENSITY,7);
    }
  else
    {
      if (readonly == READ_ONLY)
	wm_puta_at(win->Handle,0,depth,ReadOnlyColour|INTENSITY,13);
      if (readonly == OFFLINE)
	wm_puta_at(win->Handle,0,depth,OfflineColour|INTENSITY,13);
      else if (!readonly)
	wm_puta_at(win->Handle,0,depth,NameColour|INTENSITY,13);
      else if (readonly == FILE_COMMENT)
	wm_puta_at(win->Handle,0,depth,CommentColour|INTENSITY,13);
      if((win->date) && (win->size)){
	wm_puta_at(win->Handle,13,depth,DateColour|INTENSITY,9);
	wm_puta_at(win->Handle,23,depth, SizeColour|INTENSITY,7);
      }
      else if(win->date)
	wm_puta_at(win->Handle,13,depth,DateColour|INTENSITY,9);
      else if (win->size)
	wm_puta_at(win->Handle,14,depth, SizeColour|INTENSITY,7);
    }
}

void make_full_path(char * file)
{
  char tempstr[1200];
  if (file == NULL) return;
  if (!strlen(file)) return;
  if (file[1] == ':') return;
  if (file[0] == '\\')
    {
      tempstr[0] = _fngetdrive(maxdir);
      tempstr[1] = 0;
      strcat(tempstr, "\\");
      strcat(tempstr, file);
      strcpy(file, tempstr);
      return;
    }
  else
    {
      strcpy(tempstr, maxdir);
      strcat(tempstr, "\\");
      strcat(tempstr, file);
      strcpy(file, tempstr);
      return;
    }
}







int is_selected(struct Window *win, int pos)
{
  int i;
  for (i=0; i < win->numselected; ++i)
    if (win->selected[i] == pos) return 1;
  return 0;
}


void run_macro(void * PDummy)
{
  struct threadinfo * TInfo = (struct threadinfo *) PDummy;
  char * argv[20];
  char drive[_MAX_DRIVE], dir[_MAX_DIR];
  char fname[_MAX_FNAME], ext[_MAX_EXT];
  char path[256];
  char macro[81];
  int i;
  int j;
  int pid;
  int status;
  extern wm_handle main_window;


  for (j=0; j < TInfo->numfiles; ++j){
    i = 0;
    wm_puts_at(main_window, 40,0,"Macro:");
    wm_puts_at(main_window, 46, 0,mygetname(TInfo->namelist[j]));
    strcpy(macro, Macros[TInfo->new_type]);
    if (_osmode != DOS_MODE) argv[i++] = "cmd.exe";
    else argv[i++] = "command.com";
    argv[i++] = "/c";
    argv[i++] = strtok(macro, " ");
    while ((argv[i] = strtok('\0', " ")))
      ++i;

    if (_fnisrel(TInfo->namelist[j]))
      sprintf(path,"%s%s%s",TInfo->path, "\\", TInfo->namelist[j]);
    else strcpy(path, TInfo->namelist[j]);
    _splitpath (path, drive, dir, fname, ext);
    
    argv[i++] = strtok(path, " ");
    argv[i++] = strtok(drive, " ");
    argv[i++] = strtok(dir, " ");
    argv[i++] = strtok(fname, " ");
    argv[i++] = strtok(ext, " ");
    argv[i++] = '\0';

    pid = spawnv(P_SESSION|P_FOREGROUND, argv[0], argv);
    if (pid >= 0) waitpid(pid, &status, 0);
  }
  wm_puts_at(main_window,40,0,"                 ");
  wm_puta_at(main_window,40,0,F_WHITE|B_WHITE, 21);
  mem_free(PDummy);
}







void run_fbp(int numareas)
{
  FILE * runfbpcmd;
  char cwd[300];
  char cwd2[300];
  char * argv[numareas];
  int i=0, j=2;

  if (bbs_type == MAXIMUS)
    {
      argv[0] = mygetname(fbpcmd);
      argv[1] = areabbs;
    }
  else if (bbs_type == LORA)
    {
      argv[0] = strtok(fbpcmd, " ");
      argv[1] = strtok('\0'," ");
      if (!argv[1]){
	error2("you must define a *.idx file",
	       "on which to run the file manager");
	return;}
      else argv[2] = "area";
      j = 3;
    }
  else return;
  for (i=0; i <numareas;++i)
    if (fileareas[i].backed_up)
      {
	argv[j] = fileareas[i].Area;
	++j;
      }
  argv[j] = '\0';
  if (AutoFBP){
    _getcwd2(cwd, sizeof(cwd));
    _chdir2(maxdir);
    _getcwd2(cwd2, sizeof(cwd2));
    if (j != 2 + (bbs_type == LORA))
      spawnv( P_WAIT, argv[0], argv);
    _chdir2(cwd);}
  else
    {
      if (!(runfbpcmd = fopen("runfbp.cmd", "w"))){
	error2("could not open the file runfbp.cmd for writing",
	       "this file will not be created...");
	return;}
      if (j != 2 + (bbs_type == LORA)){
	strcpy(cwd, maxdir);
	cwd[2] = 0;
	fprintf(runfbpcmd,"%s\n",cwd);
	fprintf(runfbpcmd,"cd %s\n",&maxdir[2]);
	for (i = 0; argv[i]; ++i)
	  fprintf(runfbpcmd,"%s ", argv[i]);
	fclose(runfbpcmd);
      }
    }
}






void WriteDesc(FILE * fp, char * fname, char * desc)
{
  int numstrings = 200;
  char ** strings;
  int depth = 0;
  char * p;
  char * eol;
  char more = 1;
  char * root;
  int width = 79 - FileListMargin;
  int i;
  char * buffer;
  int depth2 = 101;
  int j;
  char store;


  if (!FileListMargin) fprintf(fp, "%s %s\n", fname, desc);
  else
    {
      strings = mem_malloc(numstrings*sizeof(char *));
      buffer = mem_malloc((FileListMargin+1) * sizeof(char));
      for (i=0; i < FileListMargin; ++i) buffer[i] = ' ';
      buffer[FileListMargin] = 0;
      p = mem_strdup(desc);
      root = p;
      eol = p;
      while (more){
	while ((*eol) && (*eol != '\n')) ++eol;
	more = *eol;
	*eol = 0;
	if (more) ++eol;
	strings[depth++] = mem_strdup(p);
	p = eol;
      }
      mem_free(root);
      for (i=0; i < depth; ++i)
	if (strlen(strings[i]) > width)
	  i = depth+10;
      if (i >= depth+10)
	{
	  depth2 = 100;
	  for (j=0; j < depth; ++j)
	    {
	      p = strings[j];
	      if (strlen(strings[j]) < width)
		strings[depth2++] = mem_strdup(strings[j]);
	      else
		{
		  more = 1;
		  p = strings[j];
		  while (more){
		    eol = &p[ min(width, strlen(p))];
		    if (strlen(p) < width){
		      strings[depth2++] = mem_strdup(p);
		      more = 0;}
		    else {
		      while ((*eol != ' ') && (eol > p) && more)
			--eol;
		      if ( (eol == p) && more ){
			store = *p;
			p[width] = 0;
			eol = &p[width];}
		      else if (more){ *eol = 0; store = ' ';}
		      strings[depth2++] = mem_strdup(p);
		      if (more) *eol = store;
		      if (*eol == ' ') ++eol;
		      p = eol;
		    }
		  }
		}
	    }
	  for (i=0; i < depth2-100; ++i){
	    if (i < depth) mem_free(strings[i]);
	    strings[i] = strings[100+i];}
	}
      else depth2 = depth+100;
      fprintf(fp, "%s %s\n", fname, strings[0]);
      if (depth2 > 101){
	for(i=1; i < depth2-100-1; ++i)
	  fprintf(fp, "%s%s\n", buffer, strings[i]);
	fprintf(fp, "%s%s\n", buffer, strings[i]);
      }
      mem_free(buffer);
  for (i=0; i < depth2-100; mem_free(strings[i++]));
  mem_free(strings);
    }
} 








int write_filesbbs(struct Window *win, int commandline)
{
  FILE * FILESBBS;
  char temp[100];
  char FilesBKP[300];
  char FilesBBS[300];
  int write=1;
  char rc;
  struct stat finfo;
  int i, j;

  if (strlen(fileareas[win->area].FileList))
    strcpy (FilesBBS, fileareas[win->area].FileList);
  else
    sprintf(FilesBBS, "%s\\files.bbs", fileareas[win->area].Download);


  stat(FilesBBS, &finfo);
  if ((finfo.st_attr & 1) && commandline){
    fprintf(stderr,"Unable to write files.bbs: %s\n",FilesBBS);
    return 1;}
  strcpy(FilesBKP, FilesBBS);
  FilesBKP[strlen(FilesBKP)-2] = 'k';
  FilesBKP[strlen(FilesBKP)-1] = 'p';
  if (!fileareas[win->area].backed_up)
    {
      if (!(rc = MyDosCopy((UCHAR *) FilesBBS, (UCHAR *) FilesBKP, 1)))
	  fileareas[win->area].backed_up = 1;
      else if (!commandline)
	error2("The Files.bbs could not be backed up to Files.bkp",
	       _ltoa(rc, temp, 10));
    }
  if((!(FILESBBS = fopen(FilesBBS, "w"))) && (!commandline))
    {
      error2("Original Files.bbs could not be opened for updating",
	     "Screen will reflect the update that should have occured");
      write = 0;
    }
  if (write)
    {
      for (i=0; i < win->numfiles; ++i)
	{
	  if (!IsComment(win->Files[i].fname)){
	      if (!win->Files[i].wildcard)
		WriteDesc(FILESBBS, win->Files[i].fname,
			  win->Files[i].description);
	      else if ((int) win->Files[i].wildcard > 0){
		WriteDesc(FILESBBS, win->Files[i].wildcard,
			  win->Files[i].description);
		for (j=i+1; j < win->numfiles; ++j)
		  if (win->Files[i].wildcard == win->Files[j].wildcard)
		    win->Files[j].wildcard = 
		      (char *) -(int)win->Files[j].wildcard;}
	    }
	  else
	    fprintf(FILESBBS, "%s\n", win->Files[i].description);
	}
      fclose(FILESBBS);
    }
  for (i=0; i < win->numfiles; ++i) if ((int) win->Files[i].wildcard < 0){
    win->Files[i].wildcard = (char *) -(int)win->Files[i].wildcard;}
  return write;
}


void free_window(struct Window * WIN)
{
  int i, j;
  for (i = 0; i < WIN->numfiles; ++i)
    {
      mem_free(WIN->Files[i].description);
      if (WIN->Files[i].wildcard){
	mem_free(WIN->Files[i].wildcard);
	for (j=i+1;j < WIN->numfiles; ++j)
	  if (WIN->Files[i].wildcard == WIN->Files[j].wildcard)
	    WIN->Files[j].wildcard = 0;}
    }
  mem_free(WIN->Files);
  mem_free(WIN->selected);
}


void free_mem()
{
  int i;

  mem_free(areabbs);
  mem_free(maxdir);
  mem_free(GifViewer);
  mem_free(BMPViewer);
  mem_free(JPGViewer);
  mem_free(PCXViewer);
  mem_free(TIFViewer);
  mem_free(TXTViewer);
  mem_free(VirusScanner);
  mem_free(fbpcmd);
  mem_free(DefaultDescription);
  mem_free(externaledit);
  mem_free(TempDir);
  for (i = 0; i <numMacros+1; ++i)
    if (Macros[i]) mem_free(Macros[i]);

  mem_free(fileareas);
}




void DuplicateFileInfo(struct FileInfo * File1, struct FileInfo * File2)
{
  strcpy(File1->fname, File2->fname);
  strcpy(File1->fsize, File2->fsize);
  strcpy(File1->date,  File2->date);
  File1->description = mem_strdup(File2->description);
  File1->read_only = File2->read_only;
  File1->wildcard = File2->wildcard;
  File1->area = File2->area;
}


void CopyFileInfo(struct FileInfo * File1, struct FileInfo * File2)
{
  strcpy(File1->fname, File2->fname);
  strcpy(File1->fsize, File2->fsize);
  strcpy(File1->date,  File2->date);
  File1->description = File2->description;
  File1->read_only = File2->read_only;
  File1->wildcard = File2->wildcard;
  File1->area = File2->area;
}


int max(int x, int y)
{
  return (x > y) ? x : y;
}



void ExpandWindow(struct Window * win, int num_files)
{
  win->Files=(struct FileInfo *)
    mem_realloc(win->Files, (num_files+20)*sizeof(struct FileInfo));
  win->selected = (int *)
    mem_realloc(win->selected, (num_files+20)*sizeof(int));
  win->num_free = 20;
  num_files += 20;
}
  


char newfile(time_t today, char * fdate, int days, int USA)
{
  struct tm ftm;
  time_t filetime_t;
  char * rc;
  char tmpstr[10];

  bzero( (void *) &ftm, sizeof(struct tm));
  strcpy(tmpstr, fdate);
  
  /*
     if (tmpstr[0] == '0'){
     strcpy(tmpstr, &fdate[1]);
     if (tmpstr[2] == '0') strcpy(&tmpstr[2], &fdate[4]);
     }
     */
  if (tmpstr[3] == '0') strcpy(&tmpstr[3], &fdate[4]);
  if (USA) rc = strptime( fdate, "%D", &ftm);
  else rc =strptime( fdate, "%d/%m/%y", &ftm);
  filetime_t = mktime(&ftm);

  return ((((int) (today - filetime_t))/86400) < days);
}



int MyDosCopy(char * source, char * dest, int mode)
{
  int sizeread = 10000;
  FILE * FS;
  FILE * FD;
  char buffer[sizeread];
  int amntread;

  if (_osmode != DOS_MODE) return DosCopy((PSZ) source, (PSZ) dest, mode);
  else{
    remove(dest);
    FS = fopen (source, "rb");
    FD = fopen (dest, "wb");
    while ((amntread = fread(buffer, sizeof(char), sizeread, FS)))
      if (amntread != (fwrite(buffer, sizeof(char), amntread, FD)))
	{
	  remove(dest);
	  return -1;
	}
    fclose(FS);
    fclose(FD);
    return 0;
  }
  return 0;
}





